%define ocamlname lwt

# debuginfo clashes with ocaml-bitstring
# that does not happen in 4.0.1 so lets just disable debuginfo in 3.3.0
%global debug_package %{nil}

Name:           ocaml-%{ocamlname}
Version:        3.3.0
Release:        1%{?dist}.emp1
Summary:        OCaml lightweight thread library
License:        LGPL with OpenSSL linking exception
URL:            http://ocsigen.org/%{ocamlname}
Source0:        %{ocamlname}-%{version}.tar.gz

Requires:       ocaml >= 4.02.0
Requires:	ocaml-camlp4
Requires:       ocaml-result
Requires:	ocaml-ocaml-migrate-parsetree
Requires:	ocaml-ppx_tools_versioned >= 5.0.1
Requires:       glib2
Requires:       libev

BuildRequires:  ocaml >= 4.02.0
BuildRequires:  opam-installer >= 2.0
BuildRequires:  jbuilder >= 1.0
BuildRequires:  ocaml-cppo >= 1.1.0
BuildRequires:  ocaml-findlib >= 1.7.3
BuildRequires:	ocaml-camlp4-devel
BuildRequires:  ocaml-result-devel
BuildRequires:	ocaml-ocaml-migrate-parsetree-devel
BuildRequires:	ocaml-ppx_tools_versioned-devel >= 5.0.1
BuildRequires:  glib2-devel
BuildRequires:  libev-devel

%description
Lwt is a lightweight thread library for Objective Caml.  This library
is part of the Ocsigen project.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-camlp4-devel
Requires:       ocaml-result-devel
Requires:	ocaml-ocaml-migrate-parsetree-devel
Requires:	ocaml-ppx_tools_versioned-devel >= 5.0.1
%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-%{version}

%build
ocaml src/util/configure.ml -use-libev true -use-camlp4 true
jbuilder build  -p %{ocamlname} %{?_smp_mflags}
ocaml src/util/install_filter.ml

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
echo %{ocamlname} > \
    %{buildroot}/%{_libdir}/ocaml/stublibs/dll%{ocamlname}_unix_stubs.so.owner

%check
jbuilder runtest -p %{ocamlname} %{?_smp_mflags}

%files
%doc doc/LICENSE doc/COPYING
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner


%files devel
%doc doc/apiref-intro doc/CONTRIBUTING.md doc/descr doc/Makefile doc/manual.wiki doc/menu.wiki
%doc %{_libdir}/ocaml/doc/%{ocamlname}/*
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
